package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/backdrop.png")] public static var ImgBackDrop:Class;
		[Embed(source = "data/lionrun.png")] public static var ImgLion:Class;
		[Embed(source = "data/animal.png")] public static var ImgAntelope:Class;
		[Embed(source = "data/deadanimal.png")] public static var ImgRoadkill:Class;
		[Embed(source = "data/tree.png")] public static var ImgTree:Class;

		[Embed(source = "data/yum4.mp3")] public static var Snd1:Class;
		[Embed(source = "data/yum3.mp3")] public static var Snd2:Class;
		[Embed(source = "data/yum2.mp3")] public static var Snd3:Class;
		[Embed(source = "data/yum1.mp3")] public static var Snd4:Class;
		[Embed(source = "data/ant4.mp3")] public static var Snd5:Class;
		[Embed(source = "data/ant3.mp3")] public static var Snd6:Class;
		[Embed(source = "data/ant2.mp3")] public static var Snd7:Class;
		[Embed(source = "data/ant1.mp3")] public static var Snd8:Class;
		[Embed(source = "data/ohno.mp3")] public static var Snd9:Class;
		[Embed(source = "data/eat3.mp3")] public static var Snd10:Class;
		[Embed(source = "data/eat2.mp3")] public static var Snd11:Class;
		[Embed(source = "data/eat1.mp3")] public static var Snd12:Class;

		[Embed(source = "data/level1.txt", mimeType="application/octet-stream")] public static var Level1:Class;
//		[Embed(source = "data/bg.png")] private var BgImg:Class;
//		[Embed(source = "data/woman.png")] private var ImgWoman:Class;
		[Embed(source = "data/somesortoftune.mp3")] public static var SndMusic:Class;
//		[Embed(source = "data/sound.mp3")] public static var SndSound:Class;
//		[Embed(source = "data/gameover.mp3")] public static var SndGameover:Class;

		
		public var antelopes:FlxGroup; 
		public var deadAnimals:FlxGroup; 
		public var trees:FlxGroup; 
		
		public var hud:FlxText;
		public var scoretxt:FlxText;
		
		public static var score:int;
		
		public var player:Player;
		public var flowers:FlxGroup;
		public var endDoor:EndDoor;
		public var openflowers:FlxGroup;
		public var others:FlxGroup;
		public var collisionGroup:FlxGroup;
		public var spikes:FlxGroup;
		public static var lunging:Number; 
		
		public var bg1:FlxSprite;
		public var bg2:FlxSprite;
		public const bgSpeed:Number = 140;
		public var timeLeft:Number;
		
		override public function create():void
		{		
			timeLeft=30;
			score=0;
			FlxG.play(Snd9);
			
			FlxG.level=7;
			this._time=0;
			this._time2=0;
			spikes = new FlxGroup();
			collisionGroup = new FlxGroup();
			
			lunging=-1;
			bg1 = new FlxSprite(0,0,ImgBackDrop);
			bg2 = new FlxSprite(0,-FlxG.height,ImgBackDrop);
			add(bg1);
			add(bg2);
			
			
			antelopes = new FlxGroup();
			add(antelopes);
			
			deadAnimals = new FlxGroup();
			add(deadAnimals);
			
			trees = new FlxGroup();
			add(trees);
			
			// generate map
			var levelStr:String = "";

			
			flowers = new FlxGroup();
			this.add(flowers);
			
			openflowers = new FlxGroup();
			this.add(openflowers);
			
			others = new FlxGroup();
			this.add(others);			
						
			player = new Player(FlxG.width/2-3,FlxG.height-20);
			this.add(player);
							
			collisionGroup.add(player);
			//player = new Player();
			
			
			hud = new FlxText(1,1,FlxG.width,"30");
			hud.color=0xff000000;
			hud.scrollFactor.x=0;
			hud.scrollFactor.y=0;
			add(hud);
			scoretxt= new FlxText(0,0,FlxG.width-1,"0");
			scoretxt.alignment="right";
			scoretxt.color=0xff000000;
			scoretxt.scrollFactor.x=0;
			scoretxt.scrollFactor.y=0;
			add(scoretxt);
		}
		
		public function collectFlower(p:FlxSprite,f:FlxSprite):void
		{
			var _p:Player = p as Player;
			/*if (_p.hasFlower==false)
			{
				_p.hasFlower=true;
				_p.play("idleflower",true);
				f.kill();
			}*/
			
		}
		
		public function overlapOther(p:FlxSprite,o:FlxSprite):void
		{
			var _p:Player = p as Player;
			/*if (_p.hasFlower==true)
			{				
				_p.hasFlower=false;
				_p.play("idle",true);
				o.solid=false;
				o.play("bop",true);
				var openfl:OpenFlower = new OpenFlower(o.x+9,o.y);
				openflowers.add(openfl);
			}*/
			
		}
		
		public var _time:Number;
		public var _time2:Number;
		
		
		
		override public function update():void
		{
			timeLeft-=FlxG.elapsed;
			if (timeLeft<0)
			{
				FlxG.state=new EndState();
			}
			
			hud.text=Math.round(timeLeft).toString();
			
			if (lunging>0)
			{
				lunging-=FlxG.elapsed;
				player.velocity.y=-80;
			}
			else
			{
				if (FlxG.keys.justPressed("SPACE"))
				{
					lunging=0.5;
				}
			}
			//collisionGroup.collide();
			_time+=FlxG.elapsed;
			_time2+=FlxG.elapsed;
			const aWidth:Number=15;
			
			if (_time*FlxG.level>1)
			{
				if (Math.random()>0.3)
				{
					s = new FlxSprite(22+Math.random()*(102-22),-10);
					s.loadGraphic(ImgAntelope,true,true,8,13);
					s.addAnimation("run",[0,1],4);
					s.play("run");
					antelopes.add(s);
					_time=0;
				}
				else
				{
					var s:FlxSprite = new FlxSprite(22+Math.random()*(102-22),-100);
					s.loadGraphic(ImgTree);
					s.fixed=true;
					trees.add(s);
					_time=0;					
				}
			}
			
			bg1.y+=FlxG.elapsed*bgSpeed;
			bg2.y+=FlxG.elapsed*bgSpeed;
			
			for (var i:int=antelopes.members.length-1;i>=0;i--)
			{
				var a:FlxSprite = antelopes.members[i];
				a.velocity.y=40;
				
				if (lunging>0)
				{
					if (player.y<a.y)
					{
						a.velocity.y+=20;
					}
					else
					{
						a.velocity.y-=80;
					}
				}
				
				
				if (a.y>FlxG.height)
				{
					antelopes.remove(a,true);
				}
			}
			
			
			for (i=deadAnimals.members.length-1;i>=0;i--)
			{
				a = deadAnimals.members[i];
				a.velocity.y=bgSpeed;
			}
			
			
			for (i=trees.members.length-1;i>=0;i--)
			{
				a = trees.members[i];
				a.velocity.y=bgSpeed;
				
				if (a.y>FlxG.height)
				{
					trees.remove(a,true);
				}
			}
			
			FlxU.overlap(player,antelopes,onEat);
			FlxU.collide(player,trees);
			if (bg1.y>=FlxG.height)
			{
				bg1.y-=2*FlxG.height;
			}
			if (bg2.y>=FlxG.height)
			{
				bg2.y-=2*FlxG.height;
			}

			/*if (player.hasFlower)
			{
				FlxU.overlap(player,others,overlapOther);
			}*/
			super.update();
			
		}
		
		public function onEat(a:FlxSprite,b:FlxSprite):void
		{
			var s:FlxSprite = new FlxSprite(b.x,b.y,ImgRoadkill);
			var r:int=Math.random()*4;
			switch (r)
			{
				case 0:
					FlxG.play(Snd1);
					break;
				case 1:
					FlxG.play(Snd2);
					break;
				case 2:
					FlxG.play(Snd3);
					break;
				case 3:
					FlxG.play(Snd4);
					break;
			}
			
			score++;
			if (score%20==0)
			{
				r=Math.random()*4;
				switch (r)
				{
					case 0:
						FlxG.play(Snd5);
						break;
					case 1:
						FlxG.play(Snd6);
						break;
					case 2:
						FlxG.play(Snd7);
						break;
					case 3:
						FlxG.play(Snd8);
				}
			}
			else if (score%10==0)
			{
				r=Math.random()*3;
				switch (r)
				{
					case 0:
						FlxG.play(Snd10);
						break;
					case 1:
						FlxG.play(Snd11);
						break;
					case 2:
						FlxG.play(Snd12);
						break;
				}
			}
			this.scoretxt.text=score.toString();
			deadAnimals.add(s);
			b.y=FlxG.height+200;
		}
		
	}
}